#include <stdio.h>

/* cat -        */

#define MAXBUF 512

void err(){ fprintf(stderr,"cat::    cat --help\n"); }

void help(FILE* fp)
{
 fprintf(fp,"   cat -       \n");
 fprintf(fp,"  cat [] \n");
 fprintf(fp,"   cat     -   ;    \n");
 fprintf(fp,"              ;   ,  \n");
 fprintf(fp,"	   	-v        \n");
 fprintf(fp,"		    ;  \"\"\n");
 fprintf(fp,"		 koi8 ,     #  .\n");
 fprintf(fp,"\n");
 fprintf(fp,"-				   \n");
 fprintf(fp,"-b  --number-nonblank	    c 1\n");
 fprintf(fp,"-e				 -vE\n");
 fprintf(fp,"-d				 13-  (CR)\n");
 fprintf(fp,"-n  --number		   c 1\n");
 fprintf(fp,"-s  --squeeze-blank	   ,  ,  1-\n");
 fprintf(fp,"-t				 -vT\n");
 fprintf(fp,"-u				,     . UNIX-\n");
 fprintf(fp,"-v  --show-nonprinting	   (. < 32) \n");
 fprintf(fp,"				^(+64),  TAB  CR,   (.\n");
 fprintf(fp,"				>=127),  M-^(-64),   -  \n");
 fprintf(fp,"-z				     cat\n");
 fprintf(fp,"-A  --show-all		 -vET\n");
 fprintf(fp,"-E  --show-ends		 $   \n");
 fprintf(fp,"-T  --show-tabs		  Tab  ^I\n");
 fprintf(fp,"-K  --win-koi8		  ANSI  koi8\n");
 fprintf(fp,"-W  --koi8-win		  koi8  ANSI\n");
 fprintf(fp,"-k  --oem-koi8		  OEM  koi8\n");
 fprintf(fp,"-O  --koi8-oem		  koi8  OEM\n");
 fprintf(fp,"-h  --help   		    \n");
 fprintf(fp,"       --version		   \n");
}

void version(FILE* fp)
{
 fprintf(fp,"cat\n 1.2\n\n:  \n");
}

#define true '1'
#define false '\0'

static unsigned char ANSI[32]={
            254,224,225,246, 228,229,244,227, 245,232,233,234, 235,236,237,238,
	    239,255,240,241, 242,243,230,226, 252,251,231,248, 253,249,247,250};

unsigned char koi8_ansi(char c)
{
// if(c=='\n') return 13;
 if(c=='') return 184;
 if(c=='') return 168;
 if(c>='') return ANSI[c-'']-32;
 return ANSI[c-'']; 
}

static char KOI8[32]="";

char ansi_koi8(unsigned char c)
{
// if(c==13) return '\n';
// if(c==185) return '#';
 if(c==184) return '';
 if(c==168) return '';
 if(c>=224) return KOI8[c-224];
 return KOI8[c-192]+32;
}

unsigned char koi8_oem(char c)
{
 register unsigned char q;
 if(c=='') return 241;
 if(c=='') return 240;
 if(c>='') return ANSI[c-'']-96;
 q = koi8_ansi(c);
 if(q>=240) return q-16;
 return q-64;
}

char oem_koi8(unsigned char c)
{
 if(c==240) return '';
 if(c==241) return '';
// if(c==252) return '#';
 if(128<=c && c<=175) return ansi_koi8(c+64); /*    1-   */
 return ansi_koi8(c+16); /*    OEM-   2-    */
}

void cat(int ac,char* av[],FILE* fp)
{
 char buf[MAXBUF+1]; //   ; MAXBUF+1 -   $   E
 char *tmpname = NULL;
 char** files;
 char *ss; //    
 FILE* f; //  
 register i; 
 register nn = 1, nb = 1, sn = 0; // cޣ 
 register counterfiles = 0; // cޣ  -  
// 
char h;
char b;
char n;
char s;
char E;
char T;
char v;
char W;
char K;
char O;
char k;
char d;
char z;

 b = d = z = n = s = v = E = T = h = W = K = O = k = false;
 files = (char**) calloc(ac,sizeof (char**));
 
 if(ac<2) err();
 
 for(i=1; i<ac; i++)
 {
    if(strcmp(av[i],"-")==0) files[counterfiles++] = av[i];
    else if(*av[i]=='-')
    {
      if(av[i][1]=='-')
      {
       ss = av[i]+2;
       if(strcmp(ss,"number-nonblank")==0) b = true;
       else if(strcmp(ss,"number")==0) n = true;
       else if(strcmp(ss,"koi8-win")==0) W = true;
       else if(strcmp(ss,"win-koi8")==0) K = true;
       else if(strcmp(ss,"koi8-oem")==0) O = true;
       else if(strcmp(ss,"oem-koi8")==0) k = true;
       else if(strcmp(ss,"squeeze-blank")==0) s = true;
       else if(strcmp(ss,"show-all")==0) v = E = T = true;       
       else if(strcmp(ss,"show-ends")==0) E = true;
       else if(strcmp(ss,"show-tabs")==0) T = true;
       else if(strcmp(ss,"help")==0) h = true;
       else if(strcmp(ss,"version")==0){ version(fp); return;}
       else fprintf(stderr,"cat::  --`%s`\n",ss);
       } // if
      else
      for(ss=av[i]+1; *ss; ss++)
      {
       switch(*ss)
       {
        case 'b': b = true; break;
        case 'n': n = true; break;
        case 's': s = true; break;
        case 'E': E = true; break;
        case 'T': T = true; break;
        case 'W': W = true; break;
        case 'K': K = true; break;
        case 'k': k = true; break;	
        case 'O': O = true; break;
        case 'v': v = true; break;
        case 'h': h = true; break;
        case 'u':           break;
        case 'e': v = E = true; break;	
        case 't': v = T = true; break;		
	case 'A': v = E = T = true; break;
	case 'd': d = true; break;
	case 'z': z = true; break;

        default: fprintf(stderr,"cat::  -`%c'\n",*ss);
       } // switch
      } // for
     } // if 
    else files[counterfiles++] = av[i];
 } // for
 
 
 if( h ){ help(fp); return;}
 if( K && (W || O) || W && O || k && (K || W || O))
 {
  fprintf(stderr,"cat:: -k -O -K  -W    .\n");
  return;
 } 

 for(i = 0; i<counterfiles; i++)
 {
  if(strcmp(files[i],"-")==0) f = stdin;
  else f = fopen(files[i],"rb");
  
  
  if(f==NULL) 
  {
   fprintf(stderr,"cat::    `%s`.\n",files[i]);
   continue;
  }
  
  
  if(z)
  {
   tmpname = tmpnam(NULL);
   fp = fopen(tmpname, "wb+");
   if(!fp)
   {
    fprintf(stderr,"cat::    .\n");
    continue;   
   }
  }
 
  while(!feof(f))
  {
   if( !fgets(buf,MAXBUF,f) ) buf[0]='\0';
   
   if( E ){ ss = (char*)strchr(buf,'\n'); //   E
            if(ss) {*ss = '$'; *(ss+1) = '\n'; *(ss+2) = '\0'; }}

      if( *buf=='\n' ) sn++; else sn=0; //   s
      
      if( b ) if( *buf!='\n' ) fprintf(fp,"%6i ",nb++); //   b
      if(! (s && sn!=0) ) //   s: ""  
      {
        register unsigned char c;
        ss = buf;

       if( n ) fprintf(fp,"%6i ",nn++); //   n: ޣ 
       
        while( *ss )
	{
	 c = *ss;
	 if( W && (c==163 || c==179 || c>=192) )
	    fprintf(fp,"%c",koi8_ansi(c));
	 else if( K && (c==184 || c==168 || c==185 || c>=192) )
	    fprintf(fp,"%c",ansi_koi8(c));
	 else if( O && (c==163 || c==179 || c>=192) )    
	    fprintf(fp,"%c",koi8_oem(c));
	 else if( O && c=='\n' )
	    fprintf(fp,"\r\n"); //      - 13,10;  koi - 10;  ANSI - 13
	 else if( k && (128<=c && c<=175 || 224<=c && c<=241 || c==252) )
	    fprintf(fp,"%c",oem_koi8(c));
	 else if( d && c==13 ){} //  13- .
	 else if( T && c=='\t' )
	    fprintf(fp,"^I");
	 else if( v && c < 32 && c!='\n' && c!='\t')
	    fprintf(fp,"^%c",c+64);
	 else if( v && 127 <= c)
	    fprintf(fp,"M-^%c",c-64);
	 else 
	    fprintf(fp,"%c",c);
	 ss++;
	} // while *ss
      } // if s

  } // while
  
  if(f!=stdin) fclose(f);
  
  if(z)
  {
   int res;
   fclose(fp);
   res = rename(tmpname, files[i]);
   if(res){ perror("cat:"); continue;}
  }
 }
 free(files);
}

int main(int ac, char** av)
{
 cat(ac,av,stdout);
}
